//includeți biblioteca utilizată de protocolul I2C
#include <Wire.h> 

//includeți biblioteca special creată pentru utilizarea
//unui LCD 1602 prin protocolul I2C
#include <LiquidCrystal_I2C.h>
#include <TimerOne.h>

LiquidCrystal_I2C lcd(0x3F,16,2);
const int photoresistorPin = A0;
const int gasSensorPin = A1;
const int greenLEDPin = 2;
const int yellowLEDPin = 4;
const int redLEDPin = 7;
const int buzzerPin = 10;
const unsigned long timeForInterrupt = 5000000;
int needsChecking = 0;
int buzzed = 0;
int checks_after_buzzed = 0;

void setup()
{
  // pornire ecran
  lcd.init();
  //pornire lumina backlight
  lcd.backlight();
  pinMode(greenLEDPin, OUTPUT);
  pinMode(yellowLEDPin, OUTPUT);
  pinMode(redLEDPin, OUTPUT);
  pinMode(buzzerPin, OUTPUT);
  Timer1.initialize(timeForInterrupt);
  Timer1.attachInterrupt(interruptForChecking);
}


void loop()
{
  lcd.setCursor(0, 0);
  lcd.print("Scor aer: ");
  // analogWrite(buzzerPin, 200);
  //nu se execută nicio instrucțiune în loop
  if (needsChecking == 1) {
    lcd.setCursor(0, 1); // Set cursor to the beginning of row 1
    lcd.print("                "); // Print spaces to clear the row
    int gasInAir = analogRead(gasSensorPin);
    int lightValue = analogRead(photoresistorPin);
    if (lightValue > 10) {
      analogWrite(buzzerPin, 40);
      delay(500);
    }
    int score = 1023 / (gasInAir + 1);
    lcd.setCursor(0, 1);
    lcd.print(score);
    //lcd.print(gasInAir);
    if (gasInAir > 450) {
      digitalWrite(greenLEDPin, LOW);
      digitalWrite(yellowLEDPin, LOW);
      digitalWrite(redLEDPin, HIGH);
      lcd.setCursor(5, 1);
      lcd.print("(BAD!)         ");
      if (buzzed == 0) {
        digitalWrite(buzzerPin, HIGH);
        delay(2000);
        digitalWrite(buzzerPin, LOW);
        buzzed = 1;
      }
    } else if (gasInAir > 200 && gasInAir <= 450) {
      digitalWrite(greenLEDPin, LOW);
      digitalWrite(redLEDPin, LOW);
      digitalWrite(yellowLEDPin, HIGH);
      lcd.setCursor(5, 1);
      lcd.print("(MEDIUM!)       ");
    } else if (gasInAir <= 200) {
      digitalWrite(redLEDPin, LOW);
      digitalWrite(yellowLEDPin, LOW);
      digitalWrite(greenLEDPin, HIGH);
      lcd.setCursor(5, 1);
      lcd.print("(GOOD!)   ");
    }
    needsChecking = 0;
    if (buzzed == 1 && checks_after_buzzed < 6) {
      checks_after_buzzed++;
    }
    if (buzzed == 1 && checks_after_buzzed >= 6) {
      buzzed = 0;
      checks_after_buzzed = 0;
    }
  }
}

void interruptForChecking() {
  needsChecking = 1;
}
